// components/metrics/dwa/mojom/dwa_interface.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_METRICS_DWA_MOJOM_DWA_INTERFACE_MOJOM_SHARED_H_
#define COMPONENTS_METRICS_DWA_MOJOM_DWA_INTERFACE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/metrics/dwa/mojom/dwa_interface.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace metrics::dwa::mojom {
class DwaEntryDataView;



}  // metrics::dwa::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::metrics::dwa::mojom::DwaEntryDataView> {
  using Data = ::metrics::dwa::mojom::internal::DwaEntry_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace metrics::dwa::mojom {
// Interface base classes. They are used for type safety check.
class DwaRecorderClientInterfaceInterfaceBase {};

using DwaRecorderClientInterfacePtrDataView =
    mojo::InterfacePtrDataView<DwaRecorderClientInterfaceInterfaceBase>;
using DwaRecorderClientInterfaceRequestDataView =
    mojo::InterfaceRequestDataView<DwaRecorderClientInterfaceInterfaceBase>;
using DwaRecorderClientInterfaceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DwaRecorderClientInterfaceInterfaceBase>;
using DwaRecorderClientInterfaceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DwaRecorderClientInterfaceInterfaceBase>;
class DwaRecorderInterfaceInterfaceBase {};

using DwaRecorderInterfacePtrDataView =
    mojo::InterfacePtrDataView<DwaRecorderInterfaceInterfaceBase>;
using DwaRecorderInterfaceRequestDataView =
    mojo::InterfaceRequestDataView<DwaRecorderInterfaceInterfaceBase>;
using DwaRecorderInterfaceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DwaRecorderInterfaceInterfaceBase>;
using DwaRecorderInterfaceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DwaRecorderInterfaceInterfaceBase>;
class DwaRecorderFactoryInterfaceBase {};

using DwaRecorderFactoryPtrDataView =
    mojo::InterfacePtrDataView<DwaRecorderFactoryInterfaceBase>;
using DwaRecorderFactoryRequestDataView =
    mojo::InterfaceRequestDataView<DwaRecorderFactoryInterfaceBase>;
using DwaRecorderFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DwaRecorderFactoryInterfaceBase>;
using DwaRecorderFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DwaRecorderFactoryInterfaceBase>;


class DwaEntryDataView {
 public:
  DwaEntryDataView() = default;

  DwaEntryDataView(
      internal::DwaEntry_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  uint64_t event_hash() const {
    return data_->event_hash;
  }
  uint64_t content_key_hash() const {
    return data_->content_key_hash;
  }
  inline void GetStudiesDataView(
      mojo::MapDataView<uint32_t, uint32_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadStudies(UserType* output) {
    
    auto* pointer = data_->studies.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint32_t, uint32_t>>(
        pointer, output, message_);
  }
  inline void GetMetricsDataView(
      mojo::MapDataView<uint64_t, int64_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadMetrics(UserType* output) {
    
    auto* pointer = data_->metrics.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint64_t, int64_t>>(
        pointer, output, message_);
  }
 private:
  internal::DwaEntry_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // metrics::dwa::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::metrics::dwa::mojom::DwaEntryDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::metrics::dwa::mojom::DwaEntryDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::metrics::dwa::mojom::internal::DwaEntry_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->event_hash = Traits::event_hash(input);
    fragment->content_key_hash = Traits::content_key_hash(input);
    decltype(Traits::studies(input)) in_studies = Traits::studies(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->studies)::BaseType>
        studies_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& studies_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<uint32_t, uint32_t>>(
        in_studies, studies_fragment, &studies_validate_params);
    fragment->studies.Set(
        studies_fragment.is_null() ? nullptr : studies_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->studies.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null studies in DwaEntry struct");
    decltype(Traits::metrics(input)) in_metrics = Traits::metrics(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->metrics)::BaseType>
        metrics_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& metrics_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<uint64_t, int64_t>>(
        in_metrics, metrics_fragment, &metrics_validate_params);
    fragment->metrics.Set(
        metrics_fragment.is_null() ? nullptr : metrics_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->metrics.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null metrics in DwaEntry struct");
  }

  static bool Deserialize(::metrics::dwa::mojom::internal::DwaEntry_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::metrics::dwa::mojom::DwaEntryDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace metrics::dwa::mojom {

inline void DwaEntryDataView::GetStudiesDataView(
    mojo::MapDataView<uint32_t, uint32_t>* output) {
  auto pointer = data_->studies.Get();
  *output = mojo::MapDataView<uint32_t, uint32_t>(pointer, message_);
}
inline void DwaEntryDataView::GetMetricsDataView(
    mojo::MapDataView<uint64_t, int64_t>* output) {
  auto pointer = data_->metrics.Get();
  *output = mojo::MapDataView<uint64_t, int64_t>(pointer, message_);
}



}  // metrics::dwa::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // COMPONENTS_METRICS_DWA_MOJOM_DWA_INTERFACE_MOJOM_SHARED_H_