// services/network/public/mojom/system_dns_resolution.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_SYSTEM_DNS_RESOLUTION_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_SYSTEM_DNS_RESOLUTION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/system_dns_resolution.mojom-features.h"  // IWYU pragma: export
#include "services/network/public/mojom/system_dns_resolution.mojom-shared.h"  // IWYU pragma: export
#include "services/network/public/mojom/system_dns_resolution.mojom-blink-forward.h"  // IWYU pragma: export
#include "services/network/public/mojom/address_family.mojom-blink-forward.h"
#include "services/network/public/mojom/address_list.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/platform/web_common.h"




namespace network::mojom::blink {

class SystemDnsResolverProxy;

template <typename ImplRefTraits>
class SystemDnsResolverStub;

class SystemDnsResolverRequestValidator;
class SystemDnsResolverResponseValidator;


class BLINK_PLATFORM_EXPORT SystemDnsResolver
    : public SystemDnsResolverInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SystemDnsResolverInterfaceBase;
  using Proxy_ = SystemDnsResolverProxy;

  template <typename ImplRefTraits>
  using Stub_ = SystemDnsResolverStub<ImplRefTraits>;

  using RequestValidator_ = SystemDnsResolverRequestValidator;
  using ResponseValidator_ = SystemDnsResolverResponseValidator;
  enum MethodMinVersions : uint32_t {
    kResolveMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Resolve_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~SystemDnsResolver() = default;


  using ResolveCallback = base::OnceCallback<void(::network::mojom::blink::AddressListPtr, int32_t, int32_t)>;
  
  virtual void Resolve(const WTF::String& hostname, ::network::mojom::blink::AddressFamily addr_family, int32_t flags, uint64_t network, ResolveCallback callback) = 0;
};



class BLINK_PLATFORM_EXPORT SystemDnsResolverProxy
    : public SystemDnsResolver {
 public:
  using InterfaceType = SystemDnsResolver;

  explicit SystemDnsResolverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Resolve(const WTF::String& hostname, ::network::mojom::blink::AddressFamily addr_family, int32_t flags, uint64_t network, ResolveCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT SystemDnsResolverStubDispatch {
 public:
  static bool Accept(SystemDnsResolver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SystemDnsResolver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SystemDnsResolver>>
class SystemDnsResolverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SystemDnsResolverStub() = default;
  ~SystemDnsResolverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SystemDnsResolverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SystemDnsResolverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT SystemDnsResolverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT SystemDnsResolverResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // network::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_SYSTEM_DNS_RESOLUTION_MOJOM_BLINK_H_