// services/viz/public/mojom/compositing/compositing_mode_watcher.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/viz/public/mojom/compositing/compositing_mode_watcher.mojom-features.h"  // IWYU pragma: export
#include "services/viz/public/mojom/compositing/compositing_mode_watcher.mojom-shared.h"  // IWYU pragma: export
#include "services/viz/public/mojom/compositing/compositing_mode_watcher.mojom-forward.h"  // IWYU pragma: export
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace viz::mojom {

class CompositingModeWatcherProxy;

template <typename ImplRefTraits>
class CompositingModeWatcherStub;

class CompositingModeWatcherRequestValidator;


class CompositingModeWatcher
    : public CompositingModeWatcherInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = CompositingModeWatcherInterfaceBase;
  using Proxy_ = CompositingModeWatcherProxy;

  template <typename ImplRefTraits>
  using Stub_ = CompositingModeWatcherStub<ImplRefTraits>;

  using RequestValidator_ = CompositingModeWatcherRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCompositingModeFallbackToSoftwareMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CompositingModeFallbackToSoftware_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~CompositingModeWatcher() = default;

  
  virtual void CompositingModeFallbackToSoftware() = 0;
};

class CompositingModeReporterProxy;

template <typename ImplRefTraits>
class CompositingModeReporterStub;

class CompositingModeReporterRequestValidator;


class CompositingModeReporter
    : public CompositingModeReporterInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = CompositingModeReporterInterfaceBase;
  using Proxy_ = CompositingModeReporterProxy;

  template <typename ImplRefTraits>
  using Stub_ = CompositingModeReporterStub<ImplRefTraits>;

  using RequestValidator_ = CompositingModeReporterRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAddCompositingModeWatcherMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct AddCompositingModeWatcher_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~CompositingModeReporter() = default;

  
  virtual void AddCompositingModeWatcher(::mojo::PendingRemote<CompositingModeWatcher> watcher) = 0;
};



class  CompositingModeWatcherProxy
    : public CompositingModeWatcher {
 public:
  using InterfaceType = CompositingModeWatcher;

  explicit CompositingModeWatcherProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CompositingModeFallbackToSoftware() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  CompositingModeReporterProxy
    : public CompositingModeReporter {
 public:
  using InterfaceType = CompositingModeReporter;

  explicit CompositingModeReporterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddCompositingModeWatcher(::mojo::PendingRemote<CompositingModeWatcher> watcher) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  CompositingModeWatcherStubDispatch {
 public:
  static bool Accept(CompositingModeWatcher* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      CompositingModeWatcher* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<CompositingModeWatcher>>
class CompositingModeWatcherStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CompositingModeWatcherStub() = default;
  ~CompositingModeWatcherStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CompositingModeWatcherStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CompositingModeWatcherStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  CompositingModeReporterStubDispatch {
 public:
  static bool Accept(CompositingModeReporter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      CompositingModeReporter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<CompositingModeReporter>>
class CompositingModeReporterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CompositingModeReporterStub() = default;
  ~CompositingModeReporterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CompositingModeReporterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CompositingModeReporterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  CompositingModeWatcherRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  CompositingModeReporterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // viz::mojom

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_H_